当前位置 : 主页 > 编程语言 > java >

Bad Hair Day (单调队列)

来源:互联网 收集:自由互联 发布时间:2022-08-15
Problem Description Some of Farmer John's N cows (1 ≤ N ≤ 80,000) are having a bad hair day! Since each cow is self-conscious about her messy hairstyle, FJ wants to count the number of other cows that can see the top of other cows' head


Problem Description

Some of Farmer John's N cows (1 ≤ N ≤ 80,000) are having a bad hair day! Since each cow is self-conscious about her messy hairstyle, FJ wants to count the number of other cows that can see the top of other cows' heads.

Each cow i has a specified height hi (1 ≤ hi ≤ 1,000,000,000) and is standing in a line of cows all facing east (to the right in our diagrams). Therefore, cow i can see the tops of the heads of cows in front of her (namely cows i+1, i+2, and so on), for as long as these cows are strictly shorter than cow i.

Consider this example:


=
= =
= - = Cows facing right -->
= = =
= - = = =
= = = = = =
1 2 3 4 5 6


Cow#1 can see the hairstyle of cows #2, 3, 4
Cow#2 can see no cow's hairstyle
Cow#3 can see the hairstyle of cow #4
Cow#4 can see no cow's hairstyle
Cow#5 can see the hairstyle of cow 6
Cow#6 can see no cows at all!

Let ci denote the number of cows whose hairstyle is visible from cow i; please compute the sum of c1 through cN.For this example, the desired is answer 3 + 0 + 1 + 0 + 1 + 0 = 5.

Input

Line 1: The number of cows, <i>N</i>. <br>Lines 2..N+1: Line <i>i</i>+1 contains a single integer that is the height of cow <i>i</i>.

Output

Line 1: A single integer that is the sum of <i>c</i><sub>1</sub> through <i>c<sub>N</sub></i>.

Sample Input

6
10
3
7
4
12
2


Sample Output


5



题目大概:

题目是羊的身高不一样,羊从左向右站着,只能看到在自己前面并且比自己低的羊。问每只羊看到的羊的加和是多少。

思路:

这道题和例题的求矩形面积有相似点,当然这个题只是求矩形面积的小小的一部分内容,只是求一点向一个方向的连续的点的数量并求和,在题量上,和求矩形面积没法比。这个题只需要一个单调队列,不断维护,并顺便求出和便好了。

代码:


#include <iostream>
#include <cstdio>
using namespace std;
int n;
int a[100000];
int r[100000];
int q[100000];
long long su;
int ri=0;
int go()
{

for(int i=1;i<=n;i++)
{
while(ri!=0&&a[i]>=r[ri])ri--;
su+=ri;
r[++ri]=a[i];

}
}
int main()
{
scanf("%d",&n);
for(int i=1;i<=n;i++)
{
scanf("%d",&a[i]);
}

go();



cout<<su;
return 0;
}




上一篇:CodeForces - 834B
下一篇:没有了
网友评论